;;;; PJWHash.scm
;;;; Kon Lovett, Jan '06

(use message-digest hashes-support hash-utils)

(declare
  (usual-integrations)
  (inline)
  (disable-interrupts)
  (no-procedure-checks)
  (no-bound-checks)
  (export
    PJWHash-prim
    PJWHash
    PJWHash:binary-digest PJWHash:digest PJWHash:primitive ) )

#>
#include "hashes.h"

/* This hash algorithm is based on work by Peter J. Weinberger of AT&T Bell Labs. */

static uint32_t
PJWHash( uint8_t *data, uint32_t length, uint32_t key )
{
    if (data) {
        for ( ; length; data++, length--) {
            uint32_t test;
            key = (key << 2) + ((uint32_t) *data);
            if ((test = (key & 0xC000))) {
                key = ((key ^ (test >> 12)) & 0x3FFF);
            }
        }
    }

    return key;
}

#undef bitsizeof
<#

(include "hashes-macros")

(gen-hash-api PJWHash)
(gen-update-proc PJWHash)
(gen-md-api PJWHash)
