;;;; TWUserMixHash-support.scm
;;;; Kon Lovett, Feb '08

(declare
  (usual-integrations)
  (inline)
  (disable-interrupts)
  (no-procedure-checks)
  (no-argc-checks)
  (no-bound-checks)
  (export
    foreign-TWUserMixHash ) )

;;;

#>
#include "hashes.h"

static uint32_t
TWUserMixHash( uint8_t *data, uint32_t length, uint32_t key, C_word mixer )
{
    /* User 32 bit Mix Function */
#   define MIX( key ) { \
        char numbuf[ C_SIZEOF_FLONUM ]; \
        C_word *ptr = (C_word *) &numbuf; \
        C_word num = C_unsigned_int_to_num( &ptr, (key) ); \
        C_save( num ); \
        num = C_callback( mixer, 1 ); \
        (key) = (uint32_t) C_num_to_unsigned_int( num ); \
        }

    if (data) {

        while (length >= sizeof( uint32_t )) {
            key += *((uint32_t *) data);
            MIX( key );
            data += sizeof( uint32_t );
            length -= sizeof( uint32_t );
        }

        switch (length) {
          /* all the case statements fall through */
        case 3 : key += (((uint32_t) data[ 2 ]) << 16);
        case 2 : key += (((uint32_t) data[ 1 ]) << 8);
        case 1 : key += (uint32_t) data[ 0 ];
          /* case 0: nothing left to add */
        }
        MIX( key );
    }

    return key;

#   undef MIX
}

#undef bitsizeof
<#

;;;

(define foreign-TWUserMixHash
  (foreign-safe-lambda unsigned-integer32
                       "TWUserMixHash" scheme-pointer unsigned-integer32
                                       unsigned-integer32
                                       scheme-object))
